/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2012 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __ui_list
#define __ui_list

#include "ui.h"
#include "font_editor.h"

struct curve_editor;

struct ui_list : ui {

  ui *current, *last;
  std::vector<ui*> uis;

  curve_editor* crved;

  font_editor fed;

  static const int MAX_EDITORS = 8;
  static const int key [MAX_EDITORS];
  static ui* ed [MAX_EDITORS];

  double esct;

  ui_list ();
  void set_current (ui* u, int ised = 1);

  bool handle_input ();

  void draw ();

  bool set_editor (const std::string& name, int screen);

};

#endif
